#include <winsock2.h>
#include <windows.h>
#include <tchar.h>

#pragma comment(lib,"ws2_32.lib")

#define IDC_EDIT_IN		    101
#define IDC_EDIT_OUT		102
#define IDC_BUTTON_SEND		103
#define IDC_BUTTON_RUN      104
#define IDC_EDIT_PORT		105
#define IDC_STATIC		    106

HWND hEditIn = NULL;
HWND hEditOut = NULL;

#define ROZMIAR_BUFORA  1024

LRESULT CALLBACK WinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

void DodajKomunikat(HWND hEdit, TCHAR *tekst)
{
	TCHAR buf[1000];
	int index = GetWindowTextLength(hEdit);
	_tcscpy_s(buf, 1000, tekst);
	_tcscat_s(buf, 1000, TEXT("\r\n"));
	SetFocus(hEdit);
	SendMessage(hEdit, EM_SETSEL, (WPARAM)index, (LPARAM)index);
	SendMessage(hEdit, EM_REPLACESEL, 0, (LPARAM)buf);
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	WNDCLASSEX wClass;
	ZeroMemory(&wClass, sizeof(WNDCLASSEX));
	wClass.cbSize = sizeof(WNDCLASSEX);
	wClass.hbrBackground = (HBRUSH)COLOR_WINDOW;
	wClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wClass.hInstance = hInst;
	wClass.lpfnWndProc = (WNDPROC)WinProc;
	wClass.lpszClassName = L"Window Class";
	wClass.style = CS_HREDRAW | CS_VREDRAW;

	if (!RegisterClassEx(&wClass))
	{
		MessageBox(NULL, TEXT("Window class creation failed"), TEXT("Window Class Failed"), MB_ICONERROR);
		return 1;
	}

	HWND hWnd = CreateWindowEx(NULL,
		TEXT("Window Class"),
		TEXT("Serwer"),
		WS_OVERLAPPEDWINDOW,
		200,
		200,
		335,
		480,
		NULL,
		NULL,
		hInst,
		NULL);

	if (!hWnd)
		MessageBox(NULL, TEXT("Window creation failed"), TEXT("Window Creation Failed"), MB_ICONERROR);

	ShowWindow(hWnd, nShowCmd);

	MSG msg;
	ZeroMemory(&msg, sizeof(MSG));

	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;
}

LRESULT CALLBACK WinProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_BUTTON_RUN:
		{
			   // Proba uruchomienia watka serwera
			   int nPort = 0;
			   TCHAR portstr[100];
			   if (!GetDlgItemText(hWnd, IDC_EDIT_PORT, portstr, 100)) portstr[0] = TCHAR('\0');
			   else nPort = _ttoi(portstr);
			  
			   TCHAR komunikat[ROZMIAR_BUFORA];
			   _stprintf_s(komunikat, ROZMIAR_BUFORA, TEXT("Prba pocznia na porcie %d"), nPort);
			   DodajKomunikat(hEditIn, komunikat);

			   break;
		}
		case IDC_BUTTON_SEND:
			// Wyslanie komunikatu do wszystkich klientow


			break;
		}
		break;
	case WM_CREATE:
	{
					  CreateWindow(TEXT("STATIC"), TEXT("Port: "),
						  WS_CHILD | WS_VISIBLE ,
						  10, 10, 30, 23, hWnd, (HMENU)IDC_STATIC,  GetModuleHandle(NULL),  NULL);

					  CreateWindow(TEXT("EDIT"), TEXT("1234"),
						  WS_CHILD | WS_VISIBLE | WS_BORDER,
						  40, 10, 50, 23, hWnd, (HMENU)IDC_EDIT_PORT, GetModuleHandle(NULL), NULL);
					 
					  HWND hWndButton2 = CreateWindow(TEXT("BUTTON"), TEXT("Run"),
						  WS_TABSTOP | WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
						  110, 10, 175, 23,
						  hWnd,
						  (HMENU)IDC_BUTTON_RUN,
						  GetModuleHandle(NULL),
						  NULL);

					  // Create incoming message box
					  hEditIn = CreateWindowEx(WS_EX_CLIENTEDGE,
						  TEXT("EDIT"), TEXT("Serwer nie jest uruchomiony.\r\n"),
						  WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_AUTOVSCROLL | ES_AUTOHSCROLL,
						  10, 50, 300, 300,
						  hWnd, 
						  (HMENU)IDC_EDIT_IN,
						  GetModuleHandle(NULL),
						  NULL);
			
					  if (!hEditIn)  MessageBox(hWnd, TEXT("Could not create incoming edit box."), TEXT("Error"), MB_OK | MB_ICONERROR);
					  
					  // Create outgoing message box
					  hEditOut = CreateWindowEx(WS_EX_CLIENTEDGE,
						  TEXT("EDIT"), TEXT("Tutaj wpisz komunikat..."),  WS_CHILD | WS_VISIBLE | ES_MULTILINE |
						  ES_AUTOVSCROLL | ES_AUTOHSCROLL ,
						  10, 360, 220, 60, hWnd,
						  (HMENU)IDC_EDIT_OUT,
						  GetModuleHandle(NULL),
						  NULL);
					  
					  if (!hEditOut) MessageBox(hWnd, TEXT("Could not create outgoing edit box."), TEXT("Error"),  MB_OK | MB_ICONERROR);
					  
					  // Create a push button
					  HWND hWndButton = CreateWindow(
						  TEXT("BUTTON"),
						  TEXT("Send"),
						  WS_TABSTOP | WS_VISIBLE |
						  WS_CHILD | BS_DEFPUSHBUTTON ,
						  240, 360, 60, 60,
						  hWnd,
						  (HMENU)IDC_BUTTON_SEND,
						  GetModuleHandle(NULL),
						  NULL);



					  EnableWindow(hEditOut, false);
					  EnableWindow(GetDlgItem(hWnd, IDC_BUTTON_SEND), false);


					  WSADATA WsaDat;
					  int nResult = WSAStartup(MAKEWORD(2, 2), &WsaDat);
					  if (nResult != 0)
					  {
						  MessageBox(hWnd, TEXT("Winsock initialization failed"), TEXT("Critical Error"), MB_ICONERROR);
						  SendMessage(hWnd, WM_DESTROY, NULL, NULL);
						  break;
					  }

					  HGDIOBJ hfDefault = GetStockObject(DEFAULT_GUI_FONT);
					  SendMessage(GetDlgItem(hWnd, IDC_EDIT_PORT), WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
					  SendMessage(GetDlgItem(hWnd, IDC_STATIC), WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
					  SendMessage(hEditOut, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
					  SendMessage(hEditIn, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
					  SendMessage(hWndButton, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
					  SendMessage(hWndButton2, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));

						
	}
		break;

	case WM_DESTROY:
	{
					   PostQuitMessage(0);
					   WSACleanup();
					   return 0;
	}
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}